Debian Bug report logs - #274747
type-handling: dependency on dpkg-dev is not required for provides

version graph

Package: type-handling; Maintainer for type-handling is GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>;

Reported by: Adrian Bunk <bunk@stusta.de>

Date: Sun, 3 Oct 2004 22:48:06 UTC

Severity: wishlist

Tags: wontfix

Found in versions 0.2.4, type-handling/0.2.23

Fixed in version 0.2.23+rm

Done: Debian FTP Masters <ftpmaster@ftp-master.debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Robert Millan <rmh@debian.org>:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to Adrian Bunk <bunk@fs.tum.de>:
New Bug report received and forwarded. Copy sent to Robert Millan <rmh@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Adrian Bunk <bunk@fs.tum.de>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: type-handling: dependency on dpkg-dev is not required for provides
Date: Mon, 04 Oct 2004 00:41:07 +0200
Package: type-handling
Version: 0.2.4
Severity: wishlist


The dependency on dpkg-dev makes it a bit harder to use
type-handling for regular dependencies (not build dependencies).


Could you split type-handling in two packages (one with the
type-handling script and the other with only the provides)?



Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to Robert Millan <rmh@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #10 received at 274747@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: Adrian Bunk <bunk@fs.tum.de>, 274747@bugs.debian.org
Subject: Re: Bug#274747: type-handling: dependency on dpkg-dev is not required for provides
Date: Mon, 4 Oct 2004 19:31:37 +0200
tags 274747 wontfix
thanks

Hi Adrian!

On Mon, Oct 04, 2004 at 12:41:07AM +0200, Adrian Bunk wrote:
> Package: type-handling
> Version: 0.2.4
> Severity: wishlist
> 
> The dependency on dpkg-dev makes it a bit harder to use
> type-handling for regular dependencies (not build dependencies).
> 
> Could you split type-handling in two packages (one with the
> type-handling script and the other with only the provides)?

I'm sorry, but the "Provides" functionality has been deprecated in favour of
the script because it used to bring trouble with buildds.  I haven't removed
it only because some packages still rely on it.

You should be able to archieve anything you wanted to do with the virtual
provides by using the type-handling script in combination with sed to
auto-generate debian/control from a template.

If you tell me which package do you need this for, I could help you by
proposing a solution that works for you.

Thanks for your interest in type-handling.

-- 
 .''`.   Proudly running Debian GNU/kFreeBSD unstable/unreleased (on UFS2+S)
: :' :
`. `'    http://www.debian.org/ports/kfreebsd-gnu
  `-



Information forwarded to debian-bugs-dist@lists.debian.org, Robert Millan <rmh@debian.org>:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to Adrian Bunk <bunk@stusta.de>:
Extra info received and forwarded to list. Copy sent to Robert Millan <rmh@debian.org>. Full text and rfc822 format available.

Message #15 received at 274747@bugs.debian.org (full text, mbox):

From: Adrian Bunk <bunk@stusta.de>
To: Robert Millan <rmh@debian.org>
Cc: 274747@bugs.debian.org
Subject: Re: Bug#274747: type-handling: dependency on dpkg-dev is not required for provides
Date: Mon, 4 Oct 2004 19:41:12 +0200
On Mon, Oct 04, 2004 at 07:31:37PM +0200, Robert Millan wrote:
> tags 274747 wontfix
> thanks
> 
> Hi Adrian!

Hi Robert!

> On Mon, Oct 04, 2004 at 12:41:07AM +0200, Adrian Bunk wrote:
> > Package: type-handling
> > Version: 0.2.4
> > Severity: wishlist
> > 
> > The dependency on dpkg-dev makes it a bit harder to use
> > type-handling for regular dependencies (not build dependencies).
> > 
> > Could you split type-handling in two packages (one with the
> > type-handling script and the other with only the provides)?
> 
> I'm sorry, but the "Provides" functionality has been deprecated in favour of
> the script because it used to bring trouble with buildds.  I haven't removed
> it only because some packages still rely on it.
> 
> You should be able to archieve anything you wanted to do with the virtual
> provides by using the type-handling script in combination with sed to
> auto-generate debian/control from a template.
> 
> If you tell me which package do you need this for, I could help you by
> proposing a solution that works for you.
>...

How can you express

  Recommends: grub | not+i386

in _binary-all_ packages without the virtual provides?


An example is education-common (although it might be solved by removing 
the recommends in this specific case).


cu
Adrian

-- 

       "Is there not promise of rain?" Ling Tan asked suddenly out
        of the darkness. There had been need of rain for many days.
       "Only a promise," Lao Er said.
                                       Pearl S. Buck - Dragon Seed




Tags added: wontfix Request was from Robert Millan <rmh@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to Robert Millan <rmh@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #22 received at 274747@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: Adrian Bunk <bunk@stusta.de>
Cc: 274747@bugs.debian.org, 273847@bugs.debian.org, "Luis R. Rodriguez" <mcgrof@ruslug.rutgers.edu>
Subject: Re: Bug#274747: type-handling: dependency on dpkg-dev is not required for provides
Date: Mon, 4 Oct 2004 20:04:17 +0200
On Mon, Oct 04, 2004 at 07:41:12PM +0200, Adrian Bunk wrote:
> 
> How can you express
> 
>   Recommends: grub | not+i386
> 
> in _binary-all_ packages without the virtual provides?

You're right, looks like there's a limitation here.  I'll leave this bug open
to see if someone can come up with another solution.

In your particular problem: when grub is not present, a Recommends on grub
has no effect, so it's safe to recommend it.  OTOH, grub2 will be multi-cpu
so you might want to have it as a fallback option, like:

  Recommends: grub | grub2

> An example is education-common (although it might be solved by removing 
> the recommends in this specific case).

I recall you sent a bug report to grub-splashimages about it.  I'm adding
CC to the maintainer.

Luis, could you make it a Recommends on grub | grub2 ?

-- 
 .''`.   Proudly running Debian GNU/kFreeBSD unstable/unreleased (on UFS2+S)
: :' :
`. `'    http://www.debian.org/ports/kfreebsd-gnu
  `-



Information forwarded to debian-bugs-dist@lists.debian.org, Robert Millan <rmh@debian.org>:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to Adrian Bunk <bunk@stusta.de>:
Extra info received and forwarded to list. Copy sent to Robert Millan <rmh@debian.org>. Full text and rfc822 format available.

Message #27 received at 274747@bugs.debian.org (full text, mbox):

From: Adrian Bunk <bunk@stusta.de>
To: Robert Millan <rmh@debian.org>
Cc: 274747@bugs.debian.org, 273847@bugs.debian.org, "Luis R. Rodriguez" <mcgrof@ruslug.rutgers.edu>
Subject: Re: Bug#274747: type-handling: dependency on dpkg-dev is not required for provides
Date: Tue, 5 Oct 2004 17:36:08 +0200
On Mon, Oct 04, 2004 at 08:04:17PM +0200, Robert Millan wrote:
> On Mon, Oct 04, 2004 at 07:41:12PM +0200, Adrian Bunk wrote:
> > 
> > How can you express
> > 
> >   Recommends: grub | not+i386
> > 
> > in _binary-all_ packages without the virtual provides?
> 
> You're right, looks like there's a limitation here.  I'll leave this bug open
> to see if someone can come up with another solution.

What's wrong with a package haing the provides type-handling currently 
has? This might be a different package than the one shipping the 
type-handling script, but it seems like a technically simple way to 
solve some problems.

> In your particular problem: when grub is not present, a Recommends on grub
> has no effect, so it's safe to recommend it.  OTOH, grub2 will be multi-cpu
> so you might want to have it as a fallback option, like:
> 
>   Recommends: grub | grub2
> 
> > An example is education-common (although it might be solved by removing 
> > the recommends in this specific case).
> 
> I recall you sent a bug report to grub-splashimages about it.  I'm adding
> CC to the maintainer.
> 
> Luis, could you make it a Recommends on grub | grub2 ?

Besides that it wouldn't solve the general problem, grub2 is according 
to debian/control currently only targeted at i386 and powerpc.

cu
Adrian

-- 

       "Is there not promise of rain?" Ling Tan asked suddenly out
        of the darkness. There had been need of rain for many days.
       "Only a promise," Lao Er said.
                                       Pearl S. Buck - Dragon Seed




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to Robert Millan <rmh@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #32 received at 274747@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: Adrian Bunk <bunk@stusta.de>
Cc: 274747@bugs.debian.org, 273847@bugs.debian.org, "Luis R. Rodriguez" <mcgrof@ruslug.rutgers.edu>
Subject: Re: Bug#274747: type-handling: dependency on dpkg-dev is not required for provides
Date: Tue, 5 Oct 2004 18:05:04 +0200
On Tue, Oct 05, 2004 at 05:36:08PM +0200, Adrian Bunk wrote:
> > 
> > You're right, looks like there's a limitation here.  I'll leave this bug open
> > to see if someone can come up with another solution.
> 
> What's wrong with a package haing the provides type-handling currently 
> has? This might be a different package than the one shipping the 
> type-handling script, but it seems like a technically simple way to 
> solve some problems.

Unfortunately virtual provides bring trouble with auto-builders, so they're
deprecated.  I'm trying to provide a solution that works for everyone by using
the script instead.

> > In your particular problem: when grub is not present, a Recommends on grub
> > has no effect, so it's safe to recommend it.  OTOH, grub2 will be multi-cpu
> > so you might want to have it as a fallback option, like:
> > 
> >   Recommends: grub | grub2
> 
> Besides that it wouldn't solve the general problem, grub2 is according 
> to debian/control currently only targeted at i386 and powerpc.

As I said before, when grub (or grub2) is not present, a Recommends on grub
(or grub2) has no effect so it's safe to use it.  It also archieves
pro-active compatibility when grub2 is ported to more cpus (which it will).

-- 
 .''`.   Proudly running Debian GNU/kFreeBSD unstable/unreleased (on UFS2+S)
: :' :
`. `'    http://www.debian.org/ports/kfreebsd-gnu
  `-



Information forwarded to debian-bugs-dist@lists.debian.org, Robert Millan <rmh@debian.org>:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to mcgrof@ruslug.rutgers.edu (Luis R. Rodriguez):
Extra info received and forwarded to list. Copy sent to Robert Millan <rmh@debian.org>. Full text and rfc822 format available.

Message #37 received at 274747@bugs.debian.org (full text, mbox):

From: mcgrof@ruslug.rutgers.edu (Luis R. Rodriguez)
To: Robert Millan <rmh@debian.org>, 273847@bugs.debian.org
Cc: Adrian Bunk <bunk@stusta.de>, 274747@bugs.debian.org
Subject: Re: Bug#273847: Bug#274747: type-handling: dependency on dpkg-dev is not required for provides
Date: Tue, 5 Oct 2004 17:08:46 -0400
On Tue, Oct 05, 2004 at 06:05:04PM +0200, Robert Millan wrote:
> On Tue, Oct 05, 2004 at 05:36:08PM +0200, Adrian Bunk wrote:
> > > 
> > > You're right, looks like there's a limitation here.  I'll leave this bug open
> > > to see if someone can come up with another solution.
> > 
> > What's wrong with a package haing the provides type-handling currently 
> > has? This might be a different package than the one shipping the 
> > type-handling script, but it seems like a technically simple way to 
> > solve some problems.
> 
> Unfortunately virtual provides bring trouble with auto-builders, so they're
> deprecated.  I'm trying to provide a solution that works for everyone by using
> the script instead.
> 
> > > In your particular problem: when grub is not present, a Recommends on grub
> > > has no effect, so it's safe to recommend it.  OTOH, grub2 will be multi-cpu
> > > so you might want to have it as a fallback option, like:
> > > 
> > >   Recommends: grub | grub2
> > 
> > Besides that it wouldn't solve the general problem, grub2 is according 
> > to debian/control currently only targeted at i386 and powerpc.
> 
> As I said before, when grub (or grub2) is not present, a Recommends on grub
> (or grub2) has no effect so it's safe to use it.  It also archieves
> pro-active compatibility when grub2 is ported to more cpus (which it will).
> 

Per another bug report I was going to just sugest for grub. I can just
now suggest grub/grub2.

Robert, which one should I use?

	Luis

-- 
GnuPG Key fingerprint = 113F B290 C6D2 0251 4D84  A34A 6ADD 4937 E20A 525E



Changed Bug submitter from Adrian Bunk <bunk@fs.tum.de> to Adrian Bunk <bunk@stusta.de>. Request was from Adrian Bunk <bunk@stusta.de> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Robert Millan <rmh@debian.org>:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to Adrian Bunk <bunk@stusta.de>:
Extra info received and forwarded to list. Copy sent to Robert Millan <rmh@debian.org>. Full text and rfc822 format available.

Message #44 received at 274747@bugs.debian.org (full text, mbox):

From: Adrian Bunk <bunk@stusta.de>
To: Robert Millan <rmh@debian.org>
Cc: 274747@bugs.debian.org, 273847-quiet@bugs.debian.org, "Luis R. Rodriguez" <mcgrof@ruslug.rutgers.edu>
Subject: Re: Bug#274747: type-handling: dependency on dpkg-dev is not required for provides
Date: Tue, 19 Oct 2004 19:12:46 +0200
On Tue, Oct 05, 2004 at 06:05:04PM +0200, Robert Millan wrote:
> On Tue, Oct 05, 2004 at 05:36:08PM +0200, Adrian Bunk wrote:
> > > 
> > > You're right, looks like there's a limitation here.  I'll leave this bug open
> > > to see if someone can come up with another solution.
> > 
> > What's wrong with a package haing the provides type-handling currently 
> > has? This might be a different package than the one shipping the 
> > type-handling script, but it seems like a technically simple way to 
> > solve some problems.
> 
> Unfortunately virtual provides bring trouble with auto-builders, so they're
> deprecated.  I'm trying to provide a solution that works for everyone by using
> the script instead.
> 
> > > In your particular problem: when grub is not present, a Recommends on grub
> > > has no effect, so it's safe to recommend it.  OTOH, grub2 will be multi-cpu
> > > so you might want to have it as a fallback option, like:
> > > 
> > >   Recommends: grub | grub2
> > 
> > Besides that it wouldn't solve the general problem, grub2 is according 
> > to debian/control currently only targeted at i386 and powerpc.
> 
> As I said before, when grub (or grub2) is not present, a Recommends on grub
> (or grub2) has no effect so it's safe to use it.  It also archieves
> pro-active compatibility when grub2 is ported to more cpus (which it will).

Besides being a RC bug according to your policy, package management 
tools are allowed to treat Recommends as Depends to aid users.

The provides in type-handling are an ideal solution for this problem.


Perhaps we are talking about different issues, since I think the 
Provides in type-handling are a solution for other problems than the 
problems you were thinking of when you invented them.


Would it be a solution if you would split the type-handling package into 
two packages?


Package: type-handling
Depends: dpkg-dev
Description: dpkg architecture generation script
 This package provides a script known as "type-handling", whose purpose is
 converting System and CPU combinations into the architecture variable names
 that dpkg can understand.
 .
 For details, see /usr/share/doc/type-handling/README.Debian.

Package: architecture-provides
Provides: i386, ...
Description: Empty package that offers Provides for convenient 
	architecture dependencies


The name and description for the second package are not perfect, but I 
hope you get the idea.


Yours
Adrian

-- 

       "Is there not promise of rain?" Ling Tan asked suddenly out
        of the darkness. There had been need of rain for many days.
       "Only a promise," Lao Er said.
                                       Pearl S. Buck - Dragon Seed




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to Robert Millan <rmh@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #49 received at 274747@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: Adrian Bunk <bunk@stusta.de>
Cc: 274747@bugs.debian.org, 273847-quiet@bugs.debian.org, "Luis R. Rodriguez" <mcgrof@ruslug.rutgers.edu>
Subject: Re: Bug#274747: type-handling: dependency on dpkg-dev is not required for provides
Date: Thu, 21 Oct 2004 19:16:12 +0200
On Tue, Oct 19, 2004 at 07:12:46PM +0200, Adrian Bunk wrote:
> 
> Besides being a RC bug according to your policy, package management 
> tools are allowed to treat Recommends as Depends to aid users.
> 
> The provides in type-handling are an ideal solution for this problem.
> 
> 
> Perhaps we are talking about different issues, since I think the 
> Provides in type-handling are a solution for other problems than the 
> problems you were thinking of when you invented them.

I think the auto-generation feature should work for you.  Would the following
syntax satisfy your needs? :

Recommends: grub [`type-handling i386 any`] \
  | grub2 [`type-handling i386,powerpc any`]

> Package: architecture-provides
> Provides: i386, ...
> Description: Empty package that offers Provides for convenient 
> 	architecture dependencies

Doing this will bring back the problems that virtual packages had with buildds.
As the maintainer, I'd have to deal with these problems which I don't want to.
If you solve the problem for me, then I won't object.  I can give you the
details if you like.

-- 
 .''`.   Proudly running Debian GNU/kFreeBSD unstable/unreleased (on UFS2+S)
: :' :
`. `'    http://www.debian.org/ports/kfreebsd-gnu
  `-



Information forwarded to debian-bugs-dist@lists.debian.org, Robert Millan <rmh@debian.org>:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to mcgrof@ruslug.rutgers.edu (Luis R. Rodriguez):
Extra info received and forwarded to list. Copy sent to Robert Millan <rmh@debian.org>. Full text and rfc822 format available.

Message #54 received at 274747@bugs.debian.org (full text, mbox):

From: mcgrof@ruslug.rutgers.edu (Luis R. Rodriguez)
To: Robert Millan <rmh@debian.org>
Cc: Adrian Bunk <bunk@stusta.de>, 274747@bugs.debian.org, 273847-quiet@bugs.debian.org
Subject: Re: Bug#274747: type-handling: dependency on dpkg-dev is not required for provides
Date: Thu, 21 Oct 2004 20:46:27 -0400
On Thu, Oct 21, 2004 at 07:16:12PM +0200, Robert Millan wrote:
> On Tue, Oct 19, 2004 at 07:12:46PM +0200, Adrian Bunk wrote:
> > 
> > Besides being a RC bug according to your policy, package management 
> > tools are allowed to treat Recommends as Depends to aid users.
> > 
> > The provides in type-handling are an ideal solution for this problem.
> > 
> > 
> > Perhaps we are talking about different issues, since I think the 
> > Provides in type-handling are a solution for other problems than the 
> > problems you were thinking of when you invented them.
> 
> I think the auto-generation feature should work for you.  Would the following
> syntax satisfy your needs? :
> 
> Recommends: grub [`type-handling i386 any`] \
>   | grub2 [`type-handling i386,powerpc any`]
> 
> > Package: architecture-provides
> > Provides: i386, ...
> > Description: Empty package that offers Provides for convenient 
> > 	architecture dependencies
> 
> Doing this will bring back the problems that virtual packages had with buildds.
> As the maintainer, I'd have to deal with these problems which I don't want to.
> If you solve the problem for me, then I won't object.  I can give you the
> details if you like.
> 

I don't understand or follow. Robert -- I'm plan on completeing a new
release today of grub-splashimages should I just add:

Recommends: grub | grub2

and remove the Depends?

	Luis

-- 
GnuPG Key fingerprint = 113F B290 C6D2 0251 4D84  A34A 6ADD 4937 E20A 525E



Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to Robert Millan <rmh@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #59 received at 274747@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: "Luis R. Rodriguez" <mcgrof@ruslug.rutgers.edu>
Cc: Adrian Bunk <bunk@stusta.de>, 274747@bugs.debian.org, 273847-quiet@bugs.debian.org
Subject: Re: Bug#274747: type-handling: dependency on dpkg-dev is not required for provides
Date: Fri, 22 Oct 2004 23:01:15 +0200
On Thu, Oct 21, 2004 at 08:46:27PM -0400, Luis R. Rodriguez wrote:
> > 
> > Recommends: grub [`type-handling i386 any`] \
> >   | grub2 [`type-handling i386,powerpc any`]
> 
> I don't understand or follow. Robert -- I'm plan on completeing a new
> release today of grub-splashimages should I just add:
> 
> Recommends: grub | grub2
> 
> and remove the Depends?

That would work, but to be strictly compliant with debian policy you'd have
to use type-handling in a Recommends line similar to the one above.  Note
that the `` brackets are not parsed in debian/control and you'd have to
auto-generate debian/control from debian/control.in to use them.  Look at
how the grub2 package does the same trick to generate the Architecture field.

-- 
 .''`.   Proudly running Debian GNU/kFreeBSD unstable/unreleased (on UFS2+S)
: :' :
`. `'    http://www.debian.org/ports/kfreebsd-gnu
  `-



Information forwarded to debian-bugs-dist@lists.debian.org, Robert Millan <rmh@debian.org>:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to Adrian Bunk <bunk@stusta.de>:
Extra info received and forwarded to list. Copy sent to Robert Millan <rmh@debian.org>. Full text and rfc822 format available.

Message #64 received at 274747@bugs.debian.org (full text, mbox):

From: Adrian Bunk <bunk@stusta.de>
To: Robert Millan <rmh@debian.org>
Cc: 274747@bugs.debian.org, 273847-quiet@bugs.debian.org, "Luis R. Rodriguez" <mcgrof@ruslug.rutgers.edu>
Subject: Re: Bug#274747: type-handling: dependency on dpkg-dev is not required for provides
Date: Mon, 25 Oct 2004 02:02:29 +0200
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

On Thu, Oct 21, 2004 at 07:16:12PM +0200, Robert Millan wrote:
> On Tue, Oct 19, 2004 at 07:12:46PM +0200, Adrian Bunk wrote:
> > 
> > Besides being a RC bug according to your policy, package management 
> > tools are allowed to treat Recommends as Depends to aid users.
> > 
> > The provides in type-handling are an ideal solution for this problem.
> > 
> > 
> > Perhaps we are talking about different issues, since I think the 
> > Provides in type-handling are a solution for other problems than the 
> > problems you were thinking of when you invented them.
> 
> I think the auto-generation feature should work for you.  Would the following
> syntax satisfy your needs? :
> 
> Recommends: grub [`type-handling i386 any`] \
>   | grub2 [`type-handling i386,powerpc any`]

As stated in the beginning of this discussion, the problematic cases are 
binary-all packages like grub-splashimages.

> > Package: architecture-provides
> > Provides: i386, ...
> > Description: Empty package that offers Provides for convenient 
> > 	architecture dependencies
> 
> Doing this will bring back the problems that virtual packages had with buildds.

The usage in Recommends can't cause problems for autobuilders.

> As the maintainer, I'd have to deal with these problems which I don't want to.
> If you solve the problem for me, then I won't object.  I can give you the
> details if you like.

Please give me the details.

cu
Adrian

- -- 

       "Is there not promise of rain?" Ling Tan asked suddenly out
        of the darkness. There had been need of rain for many days.
       "Only a promise," Lao Er said.
                                       Pearl S. Buck - Dragon Seed

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.2.5 (GNU/Linux)

iD8DBQFBfEKUmfzqmE8StAARAvFzAJ4kN9Buh/yM7NmATkqqpVbPYQtniwCfeRQD
1u5Otw5MdLExPa4f9hhSuhE=
=IoIW
-----END PGP SIGNATURE-----



Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to Robert Millan <rmh@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #69 received at 274747@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: Adrian Bunk <bunk@stusta.de>
Cc: 274747@bugs.debian.org, 273847-quiet@bugs.debian.org, "Luis R. Rodriguez" <mcgrof@ruslug.rutgers.edu>
Subject: Re: Bug#274747: type-handling: dependency on dpkg-dev is not required for provides
Date: Wed, 27 Oct 2004 18:16:20 +0200
On Mon, Oct 25, 2004 at 02:02:29AM +0200, Adrian Bunk wrote:
> > As the maintainer, I'd have to deal with these problems which I don't want to.
> > If you solve the problem for me, then I won't object.  I can give you the
> > details if you like.
> 
> Please give me the details.

See bug #226978 and all the followups and references there.  I would really
appreciate if you solved or helped solving this problem.

-- 
 .''`.   Proudly running Debian GNU/kFreeBSD unstable/unreleased (on UFS2+S)
: :' :
`. `'    http://www.debian.org/ports/kfreebsd-gnu
  `-



Information forwarded to debian-bugs-dist@lists.debian.org, Robert Millan <rmh@debian.org>:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to "Kevin B. McCarty" <kmccarty@Princeton.EDU>:
Extra info received and forwarded to list. Copy sent to Robert Millan <rmh@debian.org>. Full text and rfc822 format available.

Message #74 received at 274747@bugs.debian.org (full text, mbox):

From: "Kevin B. McCarty" <kmccarty@Princeton.EDU>
To: 274747@bugs.debian.org
Subject: type-handling and binary-all packages
Date: Tue, 14 Dec 2004 13:24:32 -0500
Hello,

I second (third, whatever) the requests not to deprecate the virtual
Provides feature of type-handling, and to split it out into a separate
empty package (upon which type-handling depends, for backwards
compatibility) that doesn't depend on dpkg-dev.

To comment on the problem that virtual Provides break sbuild:

0) Most of the uses of the type-handling virtual Provides will be in
arch-all meta-packages where one particular component doesn't exist on
every arch for whatever reason, but the meta-package should conceptually
be arch-all.  In my case, for instance, "cernlib-montecarlo" depends
upon "libisajet758-dev | m68k-linux-gnu" because the ISAJET library
doesn't compile on m68k due to a compiler bug (#225621).  No one will
build-depend on most meta-packages.

1) The relevant bug about the problem with virtual Provides (#226978)
has been reassigned to sbuild and seems to me to be an issue that must
be fixed by the sbuild maintainer(s).

2) Until #226978 is fixed, there should be a big warning in the
README.Debian file and the control file for type-handling (and the
proposed empty virtual-package-providing package) not to use its virtual
Provides in any package that someone may conceivably Build-Depend upon.

3) As type-handling maintainer, you don't have to deal with bugs about
this problem -- you would just point to the big README.Debian warning,
and reassign the bug to either sbuild or the package in question, as
seems appropriate.

regards,

-- 
Kevin B. McCarty <kmccarty@princeton.edu>   Physics Department
WWW: http://www.princeton.edu/~kmccarty/    Princeton University
GPG public key ID: 4F83C751                 Princeton, NJ 08544



Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to Robert Millan <rmh@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #79 received at 274747@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: "Kevin B. McCarty" <kmccarty@Princeton.EDU>, 274747@bugs.debian.org
Subject: Re: Bug#274747: type-handling and binary-all packages
Date: Wed, 15 Dec 2004 01:06:51 +0100
On Tue, Dec 14, 2004 at 01:24:32PM -0500, Kevin B. McCarty wrote:
> Hello,
> 
> I second (third, whatever) the requests not to deprecate the virtual
> Provides feature of type-handling, and to split it out into a separate
> empty package (upon which type-handling depends, for backwards
> compatibility) that doesn't depend on dpkg-dev.
> 
> To comment on the problem that virtual Provides break sbuild:
> 
> 0) Most of the uses of the type-handling virtual Provides will be in
> arch-all meta-packages where one particular component doesn't exist on
> every arch for whatever reason, but the meta-package should conceptually
> be arch-all.  In my case, for instance, "cernlib-montecarlo" depends
> upon "libisajet758-dev | m68k-linux-gnu" because the ISAJET library
> doesn't compile on m68k due to a compiler bug (#225621).  No one will
> build-depend on most meta-packages.

Can't you set the dependency on:

  libisajet758-dev [`type-handling -n m68k linux-gnu`]
?

-- 
 .''`.   Proudly running Debian GNU/kFreeBSD unstable/unreleased (on UFS2+S)
: :' :
`. `'    http://www.debian.org/ports/kfreebsd-gnu
  `-



Information forwarded to debian-bugs-dist@lists.debian.org, Robert Millan <rmh@debian.org>:
Bug#274747; Package type-handling. Full text and rfc822 format available.

Acknowledgement sent to "Kevin B. McCarty" <kmccarty@Princeton.EDU>:
Extra info received and forwarded to list. Copy sent to Robert Millan <rmh@debian.org>. Full text and rfc822 format available.

Message #84 received at 274747@bugs.debian.org (full text, mbox):

From: "Kevin B. McCarty" <kmccarty@Princeton.EDU>
To: 274747@bugs.debian.org
Subject: Re: Bug#274747: type-handling and binary-all packages
Date: Tue, 14 Dec 2004 20:55:04 -0500
On 12/14/2004 07:06 PM, Robert Millan wrote:
> On Tue, Dec 14, 2004 at 01:24:32PM -0500, Kevin B. McCarty wrote:
>>In my case, for instance, "cernlib-montecarlo" depends
>>upon "libisajet758-dev | m68k-linux-gnu" because the ISAJET library
>>doesn't compile on m68k due to a compiler bug (#225621).  No one will
>>build-depend on most meta-packages.
> 
> Can't you set the dependency on:
> 
>   libisajet758-dev [`type-handling -n m68k linux-gnu`]
> ?

Only if I have cernlib-montecarlo as an arch-any package.  This really
seems silly since it is a meta-package, exactly the same on every
architecture except for this one difference in dependency on m68k.  I
would much prefer it to be arch-all for this reason.

(Which gets back to the reasons that people are finding the
type-handling virtual Provides to be useful.)

regards,

-- 
Kevin B. McCarty <kmccarty@princeton.edu>   Physics Department
WWW: http://www.princeton.edu/~kmccarty/    Princeton University
GPG public key ID: 4F83C751                 Princeton, NJ 08544



Information forwarded to debian-bugs-dist@lists.debian.org, josh@joshtriplett.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#274747; Package type-handling. (Sun, 11 Oct 2009 03:51:03 GMT) Full text and rfc822 format available.

Message #87 received at 274747@bugs.debian.org (full text, mbox):

From: Josh Triplett <josh@joshtriplett.org>
To: Debian Bug Tracking System <274747@bugs.debian.org>
Subject: Re: dependency on dpkg-dev is not required for provides
Date: Sat, 10 Oct 2009 20:43:16 -0700
Package: type-handling
Version: 0.2.23
Severity: normal

This issue has just become somewhat more commonplace:
gnome-desktop-environment now uses type-handling, depending on
"gnome-mount | linux-gnu", and on "policykit-1-gnome | not+linux-gnu".
Note that gnome-desktop-environment, as a metapackage, uses
"Architecture: all".  This seems like a very useful application of
type-handling.

Please, consider splitting the provides into a separate package which
does not depend on dpkg-dev.

Thanks,
Josh Triplett

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.31-trunk-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages type-handling depends on:
ii  dpkg-dev                      1.15.4     Debian package development tools

type-handling recommends no packages.

type-handling suggests no packages.




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#274747; Package type-handling. (Mon, 12 Oct 2009 09:00:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Aurelien Jarno <aurelien@aurel32.net>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Mon, 12 Oct 2009 09:00:02 GMT) Full text and rfc822 format available.

Message #92 received at 274747@bugs.debian.org (full text, mbox):

From: Aurelien Jarno <aurelien@aurel32.net>
To: Josh Triplett <josh@joshtriplett.org>, 274747@bugs.debian.org
Cc: debian-dpkg@lists.debian.org
Subject: Re: Bug#274747: dependency on dpkg-dev is not required for provides
Date: Mon, 12 Oct 2009 10:54:07 +0200
On Sat, Oct 10, 2009 at 08:43:16PM -0700, Josh Triplett wrote:
> Package: type-handling
> Version: 0.2.23
> Severity: normal
> 
> This issue has just become somewhat more commonplace:
> gnome-desktop-environment now uses type-handling, depending on
> "gnome-mount | linux-gnu", and on "policykit-1-gnome | not+linux-gnu".
> Note that gnome-desktop-environment, as a metapackage, uses
> "Architecture: all".  This seems like a very useful application of
> type-handling.
> 
> Please, consider splitting the provides into a separate package which
> does not depend on dpkg-dev.
> 

type-handling has always been a hack to workaround missing features of
dpkg-dev, and it should disappear asap.

dpkg has already support for architecture aliases for a few years, as
far as I remember it can't be used due to missing support on the
build daemons.

Could the dpkg team (Cc:ed) can give us a more detailed status of this
feature, so that we can push it for Squeeze?

Aurelien

-- 
Aurelien Jarno	                        GPG: 1024D/F1BCDB73
aurelien@aurel32.net                 http://www.aurel32.net




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#274747; Package type-handling. (Mon, 12 Oct 2009 11:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Mon, 12 Oct 2009 11:39:08 GMT) Full text and rfc822 format available.

Message #97 received at 274747@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: Aurelien Jarno <aurelien@aurel32.net>
Cc: Josh Triplett <josh@joshtriplett.org>, 274747@bugs.debian.org, debian-dpkg@lists.debian.org
Subject: Re: Bug#274747: dependency on dpkg-dev is not required for provides
Date: Mon, 12 Oct 2009 13:05:18 +0200
Hi!

On Mon, 2009-10-12 at 10:54:07 +0200, Aurelien Jarno wrote:
> On Sat, Oct 10, 2009 at 08:43:16PM -0700, Josh Triplett wrote:
> > Package: type-handling
> > Version: 0.2.23
> > Severity: normal
> > 
> > This issue has just become somewhat more commonplace:
> > gnome-desktop-environment now uses type-handling, depending on
> > "gnome-mount | linux-gnu", and on "policykit-1-gnome | not+linux-gnu".
> > Note that gnome-desktop-environment, as a metapackage, uses
> > "Architecture: all".  This seems like a very useful application of
> > type-handling.
> > 
> > Please, consider splitting the provides into a separate package which
> > does not depend on dpkg-dev.
>
> type-handling has always been a hack to workaround missing features of
> dpkg-dev, and it should disappear asap.
> 
> dpkg has already support for architecture aliases for a few years, as
> far as I remember it can't be used due to missing support on the
> build daemons.
>
> Could the dpkg team (Cc:ed) can give us a more detailed status of this
> feature, so that we can push it for Squeeze?

That only works for arch:any packages, here the problem is related to
an arch:all package. The wildcards on arch:any packages should be
mostly usable, last time I checked it was pending for all buildd to
be switched to the new sbuild (which has such support).

Adding wildcard support to arch:all packages would imply a wait time
of one release before being usable, as the syntax of the dependncy
fields would change.

Another possibility is to switch the package to an arch:any one. It's
a metapackages anyway so it does not take much space on the servers. And
actually an argument could be made that an arch:all package which
requires different dependencies on different architectures is not a
trully arch:all package.

regards,
guillem




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#274747; Package type-handling. (Mon, 12 Oct 2009 13:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Aurelien Jarno <aurelien@aurel32.net>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Mon, 12 Oct 2009 13:33:03 GMT) Full text and rfc822 format available.

Message #102 received at 274747@bugs.debian.org (full text, mbox):

From: Aurelien Jarno <aurelien@aurel32.net>
To: Josh Triplett <josh@joshtriplett.org>, 274747@bugs.debian.org, debian-dpkg@lists.debian.org
Subject: Re: Bug#274747: dependency on dpkg-dev is not required for provides
Date: Mon, 12 Oct 2009 15:19:24 +0200
On Mon, Oct 12, 2009 at 01:05:18PM +0200, Guillem Jover wrote:
> Hi!
> 
> On Mon, 2009-10-12 at 10:54:07 +0200, Aurelien Jarno wrote:
> > On Sat, Oct 10, 2009 at 08:43:16PM -0700, Josh Triplett wrote:
> > > Package: type-handling
> > > Version: 0.2.23
> > > Severity: normal
> > > 
> > > This issue has just become somewhat more commonplace:
> > > gnome-desktop-environment now uses type-handling, depending on
> > > "gnome-mount | linux-gnu", and on "policykit-1-gnome | not+linux-gnu".
> > > Note that gnome-desktop-environment, as a metapackage, uses
> > > "Architecture: all".  This seems like a very useful application of
> > > type-handling.
> > > 
> > > Please, consider splitting the provides into a separate package which
> > > does not depend on dpkg-dev.
> >
> > type-handling has always been a hack to workaround missing features of
> > dpkg-dev, and it should disappear asap.
> > 
> > dpkg has already support for architecture aliases for a few years, as
> > far as I remember it can't be used due to missing support on the
> > build daemons.
> >
> > Could the dpkg team (Cc:ed) can give us a more detailed status of this
> > feature, so that we can push it for Squeeze?
> 
> That only works for arch:any packages, here the problem is related to
> an arch:all package. The wildcards on arch:any packages should be
> mostly usable, last time I checked it was pending for all buildd to
> be switched to the new sbuild (which has such support).
> 
> Adding wildcard support to arch:all packages would imply a wait time
> of one release before being usable, as the syntax of the dependncy
> fields would change.
> 
> Another possibility is to switch the package to an arch:any one. It's
> a metapackages anyway so it does not take much space on the servers. And
> actually an argument could be made that an arch:all package which
> requires different dependencies on different architectures is not a
> trully arch:all package.
> 

Another option is that all the Provides: part of type-handling is done
on dpkg. The current problem with the implementation:
- A rebuild of type-handling is needed each time a new architecture is
  added to dpkg.
- Provides do not always work as an alternative. This require for
  example type-handling to be installed on the build daemons 
  (technically it should be an Essential package for this to work).

That's why I am not really for more usage of type-handling, which IMHO
should simply disappear.

-- 
Aurelien Jarno	                        GPG: 1024D/F1BCDB73
aurelien@aurel32.net                 http://www.aurel32.net




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#274747; Package type-handling. (Wed, 14 Oct 2009 09:15:20 GMT) Full text and rfc822 format available.

Acknowledgement sent to Goswin von Brederlow <goswin-v-b@web.de>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Wed, 14 Oct 2009 09:15:20 GMT) Full text and rfc822 format available.

Message #107 received at 274747@bugs.debian.org (full text, mbox):

From: Goswin von Brederlow <goswin-v-b@web.de>
To: Aurelien Jarno <aurelien@aurel32.net>
Cc: Josh Triplett <josh@joshtriplett.org>, 274747@bugs.debian.org, debian-dpkg@lists.debian.org
Subject: Re: Bug#274747: dependency on dpkg-dev is not required for provides
Date: Wed, 14 Oct 2009 11:11:18 +0200
Aurelien Jarno <aurelien@aurel32.net> writes:

> On Mon, Oct 12, 2009 at 01:05:18PM +0200, Guillem Jover wrote:
> Another option is that all the Provides: part of type-handling is done
> on dpkg. The current problem with the implementation:
> - A rebuild of type-handling is needed each time a new architecture is
>   added to dpkg.
> - Provides do not always work as an alternative. This require for
>   example type-handling to be installed on the build daemons 
>   (technically it should be an Essential package for this to work).
>
> That's why I am not really for more usage of type-handling, which IMHO
> should simply disappear.

This gets even worse with multiarch.

Depending on the dpkg config (what archs to allow, and any multiarch
config will break something) the type-handling will break down.

Examples:

amd64 + i386: amd64 has not-i386 and i386 has not-amd64. It is kind of
strange that you are both i386 and not-i386 but that is multiarch for
you.

amd64 + kfreebsd-amd64: Now you have linux and not-linux.

I already saw some nice confusing effects of this with ia32-apt-get
and had to blacklist type-handling from the non-native archs.

MfG
        Goswin




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#274747; Package type-handling. (Mon, 04 Oct 2010 13:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphaël Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Mon, 04 Oct 2010 13:27:03 GMT) Full text and rfc822 format available.

Message #112 received at 274747@bugs.debian.org (full text, mbox):

From: Raphaël Hertzog <hertzog@debian.org>
To: Debian Bug Tracking System <274747@bugs.debian.org>
Subject: type-handling: avoid dpkg-dev dependency
Date: Mon, 04 Oct 2010 15:25:22 +0200
Package: type-handling
Version: 0.2.23
Severity: normal

In order to avoid the dpkg-dev dependency you can replace the
dpkg-architecture -L invocation with:
perl -MDpkg::Arch -e 'print "$_\n" foreach Dpkg::Arch::get_valid_arches();'

And then you need only a libdpkg-perl dependency.

Dpkg::Arch has not yet a stable API but it's unlikely this function will be
renamed, and even if it does, it will be easy to fix...

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'testing'), (500, 'stable'), (150, 'experimental')
Architecture: i386 (x86_64)

Kernel: Linux 2.6.32-5-amd64 (SMP w/2 CPU cores)
Locale: LANG=fr_FR.UTF-8, LC_CTYPE=fr_FR.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages type-handling depends on:
ii  dpkg-dev                      1.15.8.6   Debian package development tools

type-handling recommends no packages.

type-handling suggests no packages.

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#274747; Package type-handling. (Wed, 16 Nov 2011 14:12:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Paul Wise <pabs@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Wed, 16 Nov 2011 14:12:07 GMT) Full text and rfc822 format available.

Message #117 received at 274747@bugs.debian.org (full text, mbox):

From: Paul Wise <pabs@debian.org>
To: 274747@bugs.debian.org
Subject: type-handling: 274747: dpkg-dev dependency removal
Date: Wed, 16 Nov 2011 22:08:44 +0800
[Message part 1 (text/plain, inline)]
Hi all,

I just added Depends: linux to iotop (arch all, written in python and
depends on a Linux kernel) before I realised that type-handling pulls in
dpkg-dev. I would really appreciate it if the type-handling Provides
were split off into a second package, or maybe dpkg is the right place
for the Provides?

-- 
bye,
pabs

http://wiki.debian.org/PaulWise
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#274747; Package type-handling. (Wed, 16 Nov 2011 17:21:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Robert Millan <rmh@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Wed, 16 Nov 2011 17:21:03 GMT) Full text and rfc822 format available.

Message #122 received at 274747@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@debian.org>
To: Paul Wise <pabs@debian.org>, 274747@bugs.debian.org
Subject: Re: Bug#274747: type-handling: 274747: dpkg-dev dependency removal
Date: Wed, 16 Nov 2011 18:18:50 +0100
Hi Paul,

2011/11/16 Paul Wise <pabs@debian.org>:
> I just added Depends: linux to iotop (arch all, written in python and
> depends on a Linux kernel) before I realised that type-handling pulls in
> dpkg-dev. I would really appreciate it if the type-handling Provides
> were split off into a second package, or maybe dpkg is the right place
> for the Provides?

Given that there are only two packages that still use type-handling in
their Build-Depends (e2tools and gdb), and that both have bugs tagged
pending that fix that, I think the dpkg-dev dependency can just be
removed.

-- 
Robert Millan




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#274747; Package type-handling. (Thu, 17 Nov 2011 00:00:34 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jakub Wilk <jwilk@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Thu, 17 Nov 2011 00:00:34 GMT) Full text and rfc822 format available.

Message #127 received at 274747@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 274747@bugs.debian.org
Cc: Paul Wise <pabs@debian.org>
Subject: Re: Bug#274747: type-handling: 274747: dpkg-dev dependency removal
Date: Thu, 17 Nov 2011 00:58:30 +0100
* Robert Millan <rmh@debian.org>, 2011-11-16, 18:18:
>>I just added Depends: linux to iotop (arch all, written in python and 
>>depends on a Linux kernel) before I realised that type-handling pulls 
>>in dpkg-dev. I would really appreciate it if the type-handling 
>>Provides were split off into a second package, or maybe dpkg is the 
>>right place for the Provides?
>
>Given that there are only two packages that still use type-handling in 
>their Build-Depends (e2tools and gdb),

(There's also control-center, which is fixed only in experimental.)

>and that both have bugs tagged pending that fix that, I think the 
>dpkg-dev dependency can just be removed.

dpkg-dev is build-essential, so it shouldn't make a difference for 
packages build-depending on it.

buildcross (in experimental) depends on type-handling, though I don't 
know why.

There are also some users of virtual packages provided by type-handling:

Source: coreutils
Build-Depends: ..., libattr1-dev | not+linux-gnu, libacl1-dev | not+linux-gnu, libselinux1-dev (>= 1.32) | not+linux-gnu, ...

Source: mc
Build-Depends: ..., libgpm-dev | not+linux-gnu, ...

Source: ntp
Build-Depends: ..., libcap2-dev | not+linux-gnu, ...

Package: usb-modeswitch-data
Depends: udev (>= 0.140) | not+linux-gnu

Package: iotop
Depends: ..., linux


Given how little used type-handling is, maybe it's time to remove it?

-- 
Jakub Wilk




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#274747; Package type-handling. (Thu, 17 Nov 2011 02:15:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Thu, 17 Nov 2011 02:15:03 GMT) Full text and rfc822 format available.

Message #132 received at 274747@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 274747@bugs.debian.org, Paul Wise <pabs@debian.org>
Cc: Jakub Wilk <jwilk@debian.org>
Subject: Re: Bug#274747: type-handling: 274747: dpkg-dev dependency removal
Date: Thu, 17 Nov 2011 03:11:28 +0100
Hi!

On Thu, 2011-11-17 at 00:58:30 +0100, Jakub Wilk wrote:
> * Robert Millan <rmh@debian.org>, 2011-11-16, 18:18:
> >>I just added Depends: linux to iotop (arch all, written in
> >>python and depends on a Linux kernel) before I realised that
> >>type-handling pulls in dpkg-dev. I would really appreciate it if
> >>the type-handling Provides were split off into a second package,
> >>or maybe dpkg is the right place for the Provides?

dpkg is not the right place for the Provides, those are a hack, are
overstepping on the package name space, and they should really go.

The only reason this has not happened yet is because there's still
packages depending on it on the archive.

There's also the other questionable reasons related to arch:all
packages. Used up to now to either be able to conditionalize arch
specific dependencies or as in your case to make it uninstallable
on specific arches.

But I'd argue that both those usages are bogus:

 * For the first one, if the script is portable and can work w/o the
   specific dependency on other systems, then that implies it should
   not be a Depends but a Recommends, so no need for the Provides.

 * The second case comes from conflating the two roles of arch:all
   packages, saving archive space by avoiding duplication sharing
   the same files across arches and shipping truly arch independent
   files/scripts. In the iotop case the scripts are not arch independent
   even if they are shareable. Restricting it by uninstallability is
   just another hack, the users on a package manager frontend will
   wonder why they are shown a packages they cannot possibly install,
   the Packages files get unneedingly bloated, etc. A possible clean
   solution to this could be something like: linux-all, all-i386, etc,
   for example which was discussed already during the design of the
   arch wildcards.

> >Given that there are only two packages that still use
> >type-handling in their Build-Depends (e2tools and gdb),
> 
> (There's also control-center, which is fixed only in experimental.)
> 
> >and that both have bugs tagged pending that fix that, I think the
> >dpkg-dev dependency can just be removed.
> 
> dpkg-dev is build-essential, so it shouldn't make a difference for
> packages build-depending on it.
> 
> buildcross (in experimental) depends on type-handling, though I
> don't know why.

> There are also some users of virtual packages provided by type-handling:

> Source: coreutils
> Build-Depends: ..., libattr1-dev | not+linux-gnu, libacl1-dev | not+linux-gnu, libselinux1-dev (>= 1.32) | not+linux-gnu, ...
> 
> Source: mc
> Build-Depends: ..., libgpm-dev | not+linux-gnu, ...
> 
> Source: ntp
> Build-Depends: ..., libcap2-dev | not+linux-gnu, ...
> 
> Package: usb-modeswitch-data
> Depends: udev (>= 0.140) | not+linux-gnu
> 
> Package: iotop
> Depends: ..., linux

Ah, thanks for the list Jakub! Is that exhaustive, against all
possible Provides generated by type-handling or only a selected few?

> Given how little used type-handling is, maybe it's time to remove it?

Yes, see:

  <http://lists.debian.org/debian-bsd/2011/10/msg00199.html>

I'll be filing bug reports against those packages to switch to arch
wildcards if no one beats me to it eventually. In addition those have
the problem that they will not match on things like linux-gnueabi for
example.

thanks,
guillem




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#274747; Package type-handling. (Thu, 17 Nov 2011 02:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Paul Wise <pabs@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Thu, 17 Nov 2011 02:27:03 GMT) Full text and rfc822 format available.

Message #137 received at 274747@bugs.debian.org (full text, mbox):

From: Paul Wise <pabs@debian.org>
To: Guillem Jover <guillem@debian.org>
Cc: 274747@bugs.debian.org, Jakub Wilk <jwilk@debian.org>
Subject: Re: Bug#274747: type-handling: 274747: dpkg-dev dependency removal
Date: Thu, 17 Nov 2011 10:23:57 +0800
[Message part 1 (text/plain, inline)]
On Thu, 2011-11-17 at 03:11 +0100, Guillem Jover wrote:

> dpkg is not the right place for the Provides, those are a hack, are
> overstepping on the package name space, and they should really go.
...
>  * The second case comes from conflating the two roles of arch:all
>    packages, saving archive space by avoiding duplication sharing
>    the same files across arches and shipping truly arch independent
>    files/scripts. In the iotop case the scripts are not arch independent
>    even if they are shareable. Restricting it by uninstallability is
>    just another hack, the users on a package manager frontend will
>    wonder why they are shown a packages they cannot possibly install,
>    the Packages files get unneedingly bloated, etc. A possible clean
>    solution to this could be something like: linux-all, all-i386, etc,
>    for example which was discussed already during the design of the
>    arch wildcards.

I have now switched iotop to Architecture: linux-any and dropped the
Depends: linux. Unfortunately linux-all is not available yet.

-- 
bye,
pabs

http://wiki.debian.org/PaulWise
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#274747; Package type-handling. (Thu, 17 Nov 2011 11:21:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jakub Wilk <jwilk@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Thu, 17 Nov 2011 11:21:04 GMT) Full text and rfc822 format available.

Message #142 received at 274747@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 274747@bugs.debian.org
Subject: Re: Bug#274747: type-handling: 274747: dpkg-dev dependency removal
Date: Thu, 17 Nov 2011 12:18:02 +0100
* Guillem Jover <guillem@debian.org>, 2011-11-17, 03:11:
>> There are also some users of virtual packages provided by type-handling:
>
>> Source: coreutils
>> Build-Depends: ..., libattr1-dev | not+linux-gnu, libacl1-dev | not+linux-gnu, libselinux1-dev (>= 1.32) | not+linux-gnu, ...
>>
>> Source: mc
>> Build-Depends: ..., libgpm-dev | not+linux-gnu, ...
>>
>> Source: ntp
>> Build-Depends: ..., libcap2-dev | not+linux-gnu, ...
>>
>> Package: usb-modeswitch-data
>> Depends: udev (>= 0.140) | not+linux-gnu
>>
>> Package: iotop
>> Depends: ..., linux
>
>Ah, thanks for the list Jakub! Is that exhaustive, against all possible 
>Provides generated by type-handling or only a selected few?

I believe it's exhaustive, but I'll double-check later today.

-- 
Jakub Wilk




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#274747; Package type-handling. (Fri, 18 Nov 2011 01:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jakub Wilk <jwilk@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Fri, 18 Nov 2011 01:51:03 GMT) Full text and rfc822 format available.

Message #147 received at 274747@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 274747@bugs.debian.org
Subject: Re: Bug#274747: type-handling: 274747: dpkg-dev dependency removal
Date: Fri, 18 Nov 2011 02:47:33 +0100
* Jakub Wilk <jwilk@debian.org>, 2011-11-17, 12:18:
>>>There are also some users of virtual packages provided by type-handling:
>>
>>>Source: coreutils
>>>Build-Depends: ..., libattr1-dev | not+linux-gnu, libacl1-dev | not+linux-gnu, libselinux1-dev (>= 1.32) | not+linux-gnu, ...
>>>
>>>Source: mc
>>>Build-Depends: ..., libgpm-dev | not+linux-gnu, ...
>>>
>>>Source: ntp
>>>Build-Depends: ..., libcap2-dev | not+linux-gnu, ...
>>>
>>>Package: usb-modeswitch-data
>>>Depends: udev (>= 0.140) | not+linux-gnu
>>>
>>>Package: iotop
>>>Depends: ..., linux
>>
>>Ah, thanks for the list Jakub! Is that exhaustive, against all 
>>possible Provides generated by type-handling or only a selected 
>>few?
>
>I believe it's exhaustive, but I'll double-check later today.

I set up pages to track reverse (build-) dependencies:
http://people.debian.org/~jwilk/type-handling/reverse-depends
http://people.debian.org/~jwilk/type-handling/reverse-build-depends

The code used to generate them is available here:
http://people.debian.org/~jwilk/type-handling/Makefile

-- 
Jakub Wilk




Information forwarded to debian-bugs-dist@lists.debian.org, GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>:
Bug#274747; Package type-handling. (Fri, 18 Nov 2011 18:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>. (Fri, 18 Nov 2011 18:09:03 GMT) Full text and rfc822 format available.

Message #152 received at 274747@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 274747@bugs.debian.org
Cc: Jakub Wilk <jwilk@debian.org>
Subject: Re: Bug#274747: type-handling: 274747: dpkg-dev dependency removal
Date: Fri, 18 Nov 2011 19:08:04 +0100
Hi!

On Fri, 2011-11-18 at 02:47:33 +0100, Jakub Wilk wrote:
> * Jakub Wilk <jwilk@debian.org>, 2011-11-17, 12:18:
> > > Ah, thanks for the list Jakub! Is that exhaustive, against all
> > > possible Provides generated by type-handling or only a selected
> > > few?
> >
> > I believe it's exhaustive, but I'll double-check later today.
> 
> I set up pages to track reverse (build-) dependencies:
> http://people.debian.org/~jwilk/type-handling/reverse-depends
> http://people.debian.org/~jwilk/type-handling/reverse-build-depends
> 
> The code used to generate them is available here:
> http://people.debian.org/~jwilk/type-handling/Makefile

Wonderful, thanks!

regards,
guillem




Reply sent to Debian FTP Masters <ftpmaster@ftp-master.debian.org>:
You have taken responsibility. (Tue, 20 Mar 2012 10:55:15 GMT) Full text and rfc822 format available.

Notification sent to Adrian Bunk <bunk@stusta.de>:
Bug acknowledged by developer. (Tue, 20 Mar 2012 10:55:17 GMT) Full text and rfc822 format available.

Message #157 received at 274747-done@bugs.debian.org (full text, mbox):

From: Debian FTP Masters <ftpmaster@ftp-master.debian.org>
To: 274747-done@bugs.debian.org,585767-done@bugs.debian.org,597227-done@bugs.debian.org,
Cc: type-handling@packages.debian.org, type-handling@packages.qa.debian.org
Subject: Bug#649234: Removed package(s) from unstable
Date: Tue, 20 Mar 2012 10:51:21 +0000
Version: 0.2.23+rm

Dear submitter,

as the package type-handling has just been removed from the Debian archive
unstable we hereby close the associated bug reports.  We are sorry
that we couldn't deal with your issue properly.

For details on the removal, please see http://bugs.debian.org/649234

The version of this package that was in Debian prior to this removal
can still be found using http://snapshot.debian.org/.

This message was generated automatically; if you believe that there is
a problem with it please contact the archive administrators by mailing
ftpmaster@debian.org.

Debian distribution maintenance software
pp.
Luca Falavigna (the ftpmaster behind the curtain)




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 18 Apr 2012 07:41:16 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 19:27:34 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.